﻿/*
  WORD幅のアイテムへのアクセス
*/
#include <stdio.h>
#include <unistd.h>
#include "dx2lib.h"
#include "dx2memmap.h"

// マクロ定義
#define COMPORT   "/dev/ttyUSB0"  // ポート番号
#define BAUDRATE  (2000000)       // ボーレート[bps]
#define TARGETID  (1)             // 対象となるID

void main (void) {
  int         i, f = 5;
  int32_t     pos;
  TDeviceID   dev;
  TErrorCode  err;

  if ((dev = DX2_OpenPort (COMPORT, BAUDRATE))) {
    printf("Open success\n");

    if (DX2_Ping (dev, TARGETID, &err)) {
      // 現在の位置を読み出し
      if (DX2_ReadLongData (dev, TARGETID, ADDRESS_X_PRESENT_POSITION, &pos, &err)) {
        printf ("Now position = %4d\n", pos);

        if (DX2_WriteByteData (dev, TARGETID, ADDRESS_X_TORQUE_ENABLE, 1, &err)) {
          // 何かキーを押すとループを抜ける
          for (i = 0; i < 2000; i++) {
            pos += f;
            if (pos >= 4096) { pos = 4095; f = -5; }
            else if (pos <= 0) { pos = 0; f = 5; }
            // 目標位置を書き込み
            if (DX2_WriteLongData (dev, TARGETID, ADDRESS_X_GOAL_POSITION, pos, &err))
              printf ("Sent position = %4d\r", pos);
            else
              printf ("Write error [$%04X]\n", err);
            // 5ミリ秒待ち
            usleep (5000);
          }
          DX2_WriteByteData (dev, TARGETID, ADDRESS_X_TORQUE_ENABLE, 0, &err);
        }
        printf ("\n");
      } else
        printf ("Read error [$%04X]\n", err);
    }

    DX2_ClosePort (dev);
  } else {
    printf ("Open error\n");
  }
  printf ("Fin\n");
  getchar();
}
