#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
from dx2lib import *

COMPort = b'\\\\.\\COM10'
Baudrate = 1000000

class TAngTime(Structure):
  _fields_ = [("angle", c_double * 5), ("ttime", c_double)]

# 負荷取得とスレッショルド超過継続時間判定
def CheckOverload (dev, ids, num, threshold, duration):
  overload = False
  cur=(c_double * num)()
  DXL_GetPresentCurrents(dev, ids, cur, num)
  b = False
  for i in range(num):
    if abs(cur[i]) > abs(threshold): b=True
  if b:
    if CheckOverload.tim == 0:
      CheckOverload.tim=GetQueryPerformanceCounter () + duration
    else:
      if GetQueryPerformanceCounter () > CheckOverload.tim:
        overload = True
  else:
    CheckOverload.tim = 0
  print(('{:7.1f}'*len(cur)).format(*cur)),
  if CheckOverload.tim>0:
    print("{:5.0f}ms".format(CheckOverload.tim - GetQueryPerformanceCounter ())),
  else:
    print("{:5.0f}ms".format(duration)),
  sys.stdout.write('\r')
  sys.stdout.flush()
  return overload
CheckOverload.tim = 0

def P2P (dev, id, p0, p1, num, ms):
  t0 = GetQueryPerformanceCounter ();
  t1 = t0 + ms;
  tpos=(c_double * num)
  p=tpos()
  while t1 > GetQueryPerformanceCounter ():
    if CheckOverload (dev, id, num, 620, 1000):
      return True;  # 1秒間負荷が200を超えたら抜ける
    for i in range(num):
      p[i] = p0[i] + (p1[i] - p0[i]) * (GetQueryPerformanceCounter () - t0) / (t1 - t0)
    DXL_SetGoalAngles(dev, id, p, num)
  DXL_SetGoalAngles(dev, id, p1, num)
  return False

dev = DX2_OpenPort(COMPort, Baudrate)
if dev != None:
  ids = (c_uint8 * 8)(1,2,3,4,5,6,7,8)
  for i in range(1, 9):
    print (i,DXL_GetModelInfo(dev,i).contents.name)

  DX2_SetTimeOutOffset (dev, 30);
  DXL_SetOperatingModesEquival(dev, ids, 8, 3)
  sys.stdout.flush()
  DXL_SetTorqueEnablesEquival(dev, ids, 8, True)
  uho = [
    TAngTime((0,0,0,0,0),(1000)),
    TAngTime((0,0,0,0,0),(1000)),
    TAngTime((0,0,0,0,0),(1000)),
    TAngTime((0,0,0,0,0),(1000)),
    TAngTime((0,0,0,0,0),(1000)),
    TAngTime((0,0,0,0,0),(1000)),
    TAngTime((0,0,0,0,0),(1000)),
    TAngTime((0,0,0,0,0),(1000)),
  ]
  Tpos=(c_double * 8)
  pos=[
    Tpos(   0,    0,    0,    0,    0,    0,    0,    0 ),
    Tpos( -90,  -90,  -80, -180, -180,  -80, -180, -180 ),
    Tpos( -40,    0,  -90,    0,   90,    0,  -90,    0 ),
    Tpos(   0,   90,    0,  180, -180,    0,  180, -180 ),
    Tpos(  90,    0,   90,    0,   90,    0,   90,    0 ),
    Tpos(   0,  -90,    0, -180, -180,    0, -180, -180 ),
    Tpos( -90,    0,  -90,    0,   90,  -90,    0,   90 ),
    Tpos( -80,  180,  -80,  180, -180,  -80,  180, -180 ),
  ]

  for j in range(5):
    DXL_GetPresentAngles(dev, ids, pos[0], 8)
    for i in range(7):
     if P2P (dev, ids, pos[i], pos[i+1], 8, 1500):
        break
  DXL_SetTorqueEnablesEquival(dev, ids, 8, False)

  DX2_ClosePort(dev)
#raw_input()
